Go to the first, previous, next, last section, table of contents.

# Options to the `gperf` Utility

There are many options to `gperf`. They were added to make the program more convenient for use with real applications. "On-line" help is readily available via the ``-h'` option. Other options include:

``-a'`
  Generate ANSI Standard C code using function prototypes. The default is to use "classic" K&R C function declaration syntax.
``-c'`
  Generates C code that uses the `strncmp` function to perform string comparisons. The default action is to use `strcmp`.
``-C'`
  Makes the contents of all generated lookup tables constant, i.e., "readonly." Many compilers can generate more efficient code for this by putting the tables in readonly memory.
``-d'`
  Enables the debugging option. This produces verbose diagnostics to "standard error" when `gperf` is executing. It is useful both for maintaining the program and for determining whether a given set of options is actually speeding up the search for a solution. Some useful information is dumped at the end of the program when the ``-d'` option is enabled.
``-D'`
  Handle keywords whose key position sets hash to duplicate values. Duplicate hash values occur for two reasons:
  - Since `gperf` does not backtrack it is possible for it to process all your input keywords without finding a unique mapping for each word. However, frequently only a very small number of duplicates occur, and the majority of keys still require one probe into the table.
  - Sometimes a set of keys may have the same names, but possess different attributes. With the -D option `gperf` treats all these keys as part of an equivalence class and generates a perfect hash function with multiple comparisons for duplicate keys. It is up to you to completely disambiguate the keywords by modifying the generated C code. However, `gperf` helps you out by organizing the output.
  Option ``-D'` is extremely useful for certain large or highly redundant keyword sets, i.e., assembler instruction opcodes. Using this option usually means that the generated hash function is no longer perfect. On the other hand, it permits `gperf` to work on keyword sets that it otherwise could not handle.
``-e keyword delimiter list'`
  Allows the user to provide a string containing delimiters used to separate keywords from their attributes. The default is ",\n". This option is essential if you want to use keywords that have embedded commas or newlines. One useful trick is to use -e'TAB', where TAB is the literal tab character.
``-E'`
  Define constant values using an enum local to the lookup function rather than with #defines. This also means that different lookup functions can reside in the same file. Thanks to James Clark (jjc at ai.mit.edu).
``-f iteration amount'`
  Generate the perfect hash function "fast." This decreases `gperf`'s running time at the cost of minimizing generated table-size. The iteration amount represents the number of times to iterate when resolving a collision. `0' means `iterate by the number of keywords. This option is probably most useful when used in conjunction with options ``-D'` and/or ``-S'` for large keyword sets.
``-g'`
  Assume a GNU compiler, e.g., `g++` or `gcc`. This makes all generated routines use the "inline" keyword to remove the cost of function calls. Note that ``-g'` does not imply ``-a'`, since other non-ANSI C compilers may have provisions for a function `inline` feature.
``-G'`
  Generate the static table of keywords as a static global variable, rather than hiding it inside of the lookup function (which is the default behavior).
``-h'`
  Prints a short summary on the meaning of each program option. Aborts further program execution.
``-H hash function name'`
  Allows you to specify the name for the generated hash function. Default name is `hash.' This option permits the use of two hash tables in the same file.
``-i initial value'`
  Provides an initial value for the associate values array. Default is 0. Increasing the initial value helps inflate the final table size, possibly leading to more time efficient keyword lookups. Note that this option is not particularly useful when ``-S'` is used. Also, ``-i'` is overriden when the ``-r'` option is used.
``-j jump value'`
  Affects the "jump value," i.e., how far to advance the associated character value upon collisions. Jump value is rounded up to an odd number, the default is 5. If the jump value is 0 `gper f` jumps by random amounts.
``-k keys'`
  Allows selection of the character key positions used in the keywords' hash function. The allowable choices range between 1-126, inclusive. The positions are separated by commas, e.g., ``-k 9,4,13,14'`; ranges may be used, e.g., ``-k 2-7'`; and positions may occur in any order. Furthermore, the meta-character '*' causes the generated hash function to consider all character positions in each key, whereas '$' instructs the hash function to use the "final character" of a key (this is the only way to use a character position greater than 126, incidentally). For instance, the option ``-k 1,2,4,6-10,'$''` generates a hash function that considers positions 1,2,4,6,7,8,9,10, plus the last character in each key (which may differ for each key, obviously). Keys with length less than the indicated key positions work properly, since selected key positions exceeding the key length are simply not referenced in the hash function.
``-K key name'`
  By default, the program assumes the structure component identifier for the keyword is "name." This option allows an arbitrary choice of identifier for this component, although it still must occur as the first field in your supplied `struct`.
``-l'`
  Compare key lengths before trying a string comparison. This might cut down on the number of string comparisons made during the lookup, since keys with different lengths are never compared via `strcmp`. However, using ``-l'` might greatly increase the size of the generated C code if the lookup table range is large (which implies that the switch option ``-S'` is not enabled), since the length table contains as many elements as there are entries in the lookup table.
``-L generated language name'`
  Instructs `gperf` to generate code in the language specified by the option's argument. Languages handled are currently C++ and C. The default is C.
``-n'`
  Instructs the generator not to include the length of a keyword when computing its hash value. This may save a few assembly instructions in the generated lookup table.
``-N lookup function name'`
  Allows you to specify the name for the generated lookup function. Default name is `in_word_set.' This option permits completely automatic generation of perfect hash functions, especially when multiple generated hash functions are used in the same application.
``-o'`
  Reorders the keywords by sorting the keywords so that frequently occuring key position set components appear first. A second reordering pass follows so that keys with "already determined values" are placed towards the front of the keylist. This may decrease the time required to generate a perfect hash function for many keyword sets, and also produce more minimal perfect hash functions. The reason for this is that the reordering helps prune the search time by handling inevitable collisions early in the search process. On the other hand, if the number of keywords is very large using ``-o'` may increase `gperf`'s execution time, since collisions will begin earlier and continue throughout the remainder of keyword processing. See Cichelli's paper from the January 1980 Communications of the ACM for details.
``-p'`
  Changes the return value of the generated function `in_word_set` from boolean (i.e., 0 or 1), to either type "pointer to user-defined struct," (if the ``-t'` option is enabled), or simply to `char *`, if ``-t'` is not enabled. This option is most useful when the ``-t'` option (allowing user-defined structs) is used. For example, it is possible to automatically generate the GNU C reserved word lookup routine with the options ``-p'` and ``-t'`.
``-r'`
  Utilizes randomness to initialize the associated values table. This frequently generates solutions faster than using deterministic initialization (which starts all associated values at 0). Furthermore, using the randomization option generally increases the size of the table. If `gperf` has difficultly with a certain keyword set try using ``-r'` or ``-D'`.
``-s size-multiple'`
  Affects the size of the generated hash table. The numeric argument for this option indicates "how many times larger or smaller" the maximum associated value range should be, in relationship to the number of keys. If the size-multiple is negative the maximum associated value is calculated by dividing it into the total number of keys. For example, a value of 3 means "allow the maximum associated value to be about 3 times larger than the number of input keys." Conversely, a value of -3 means "allow the maximum associated value to be about 3 times smaller than the number of input keys." Negative values are useful for limiting the overall size of the generated hash table, though this usually increases the number of duplicate hash values. If `generate switch' option ``-S'` is not enabled, the maximum associated value influences the static array table size, and a larger table should decrease the time required for an unsuccessful search, at the expense of extra table space. The default value is 1, thus the default maximum associated value about the same size as the number of keys (for efficiency, the maximum associated value is always rounded up to a power of 2). The actual table size may vary somewhat, since this technique is essentially a heuristic. In particular, setting this value too high slows down `gperf`'s runtime, since it must search through a much larger range of values. Judicious use of the ``-f'` option helps alleviate this overhead, however.
``-S total switch statements'`
  Causes the generated C code to use a `switch` statement scheme, rather than an array lookup table. This can lead to a reduction in both time and space requirements for some keyfiles. The argument to this option determines how many `switch` statements are generated. A value of 1 generates 1 `switch` containing all the elements, a value of 2 generates 2 tables with 1/2 the elements in each `switch`, etc. This is useful since many C compilers cannot correctly generate code for large `switch` statements. This option was inspired in part by Keith Bostic's original C program.
``-t'`
  Allows you to include a `struct` type declaration for generated code. Any text before a pair of consecutive %% is consider part of the type declaration. Key words and additional fields may follow this, one group of fields per line. A set of examples for generating perfect hash tables and functions for Ada, C, and G++, Pascal, and Modula 2 and 3 reserved words are distributed with this release.
``-T'`
  Prevents the transfer of the type declaration to the output file. Use this option if the type is already defined elsewhere.
``-v'`
  Prints out the current version number.
``-Z class name'`
  Allow user to specify name of generated C++ class. Default name is `Perfect_Hash`.

Go to the first, previous, next, last section, table of contents.